MODULE Colliders_PSI_1
USE MC_VEGAS
USE Helac_Global
USE Constants
USE func_psi
USE Helac_SM_FeynRule
USE Structf_PDFs
USE Helac_master
USE Helac_Func_1
USE Cuts_Module
IMPLICIT NONE
INTEGER::varnum,lnum,snum
LOGICAL::ptQ
SAVE
CONTAINS
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!  Hadronic Collider
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE BB_1FS(rslt,itmxn,ncalln)
IMPLICIT NONE
REAL(KIND=DBL),DIMENSION(3),INTENT(OUT)::rslt   ! rslt(1)=cross section ,rslt(2)=sigma,rslt(3)=chi2
INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
REAL(KIND=DBL)::vfes,sd,chi2a
INTEGER::ncalm,nc,ii
CHARACTER(len=4),DIMENSION(20)::chchar
INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
CALL ReadElem_logic("ptdisQ",ptQ)
NPRN=-1
IF(iranhel.EQ.0)THEN
   varnum = 1
   lnum = 0
   snum = 0
ELSEIF(iranhel.EQ.1)THEN
        varnum=1
        lnum=0
        snum=0
        DO ii=1,nhad
           IF(ABS(iflh(ii)).LT.40)THEN
              varnum=varnum+1
           ENDIF
        ENDDO
ELSEIF(iranhel.EQ.2)THEN
        varnum=1
        lnum=0
        snum=0
        DO ii=1,nhad
           IF(ABS(iflh(ii)).LT.40)THEN
              varnum=varnum+1
              lnum=lnum+1
           ENDIF
           IF(QN1P1F(ii).OR.QN3PJF(ii))THEN
              varnum=varnum+1
              lnum=lnum+1
           ENDIF
        ENDDO
ELSEIF(iranhel.EQ.3)THEN
        varnum=1
        DO ii=1,nhad
           IF(ABS(iflh(ii)).LT.40)THEN
              varnum=varnum+1
              lnum=lnum+1
           ENDIF
           IF(QN1P1F(ii))THEN
              varnum=varnum+1
              lnum=lnum+1
           ENDIF
           IF(QN3S1F(ii))THEN
              varnum=varnum+1
              snum=snum+1
           ENDIF
           IF(QN3PJF(ii))THEN
              varnum=varnum+2
              lnum=lnum+1
              snum=snum+1
           ENDIF
        ENDDO
ENDIF
DO ii=1,varnum
        XL(ii)=0.0d0
        XU(ii)=1.0d0
ENDDO
IF(PRESENT(itmxn))THEN
   ITMX=itmxn
ELSE
   ITMX=5
END IF
ITMX=1
IF(PRESENT(ncalln))THEN
   ncalm=ncalln
ELSE
   ncalm=5000
END IF
chchar(1)="40K"
chchar(2)="80K"
chchar(3)="160K"
chchar(4)="320K"
chchar(5)="640K"
chchar(6)="1M"
chchar(7)="2M"
chchar(8)="4M"
chchar(9)="8M"
chchar(10)="16M"
chchar(11)='32M'
chchar(12)='64M'
chchar(13)='120M'
chchar(14)='240M'
chchar(15)='480M'
chchar(16)='960M'
chchar(17)='2G'
chchar(18)='4G'
chchar(19)='8G'
chchar(20)='16G'
! call vegas and result                                                         
NCALL=20000
CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
IF(measurespeed)THEN
   NCALL=500
   CALL VEGAS(varnum,BB_1FS_fxn,vfes,sd,chi2a)
   CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
   iyr1=iyr1-iyr0
   imon1=imon1-imon0
   iday1=iday1-iday0
   ihr1=ihr1-ihr0
   imin1=imin1-imin0
   isec1=isec1-isec0
   i100th1=i100th1-i100th0
   CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
   NCALL=20000
ENDIF
CALL VEGAS(varnum,BB_1FS_fxn,vfes,sd,chi2a)
WRITE(*,*)' '
WRITE(*,*)"====================NCALL=20K==========================="
WRITE(*,*)" "
CALL Helac_mtime()
WRITE(*,*)" "
ii=1
WRITE(*,*)"ITERATION ",ii,":"
WRITE(*,*)vfes,"+\-",sd
WRITE(*,*)"precision:",sd/vfes
DO ii=2,10
        CALL VEGAS(varnum,BB_1FS_fxn,vfes,sd,chi2a,1)
        WRITE(*,*)"ITERATION ",ii,":"
        WRITE(*,*)vfes,"+\-",sd
        WRITE(*,*)"precision:",sd/vfes
ENDDO
CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
iday1=iday1-iday0
ihr1=ihr1-ihr0
imin1=imin1-imin0
isec1=isec1-isec0
i100th1=i100th1-i100th0
CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
WRITE(*,*)' '
WRITE(*,*)' '
ii=1
DO
  nc=2*NCALL
  IF(nc.GT.ncalm)EXIT
  NCALL=nc
  !CALL GETDAT(iyr0,imon0,iday0)                                                
  !CALL GETTIM(ihr0,imin0,isec0,i100th0)                                        
  CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
  WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
  WRITE(*,*)" "
  CALL Helac_mtime()
  WRITE(*,*)" "
  CALL VEGAS(varnum,BB_1FS_fxn,vfes,sd,chi2a,1)
  WRITE(*,*)vfes,"+\-",sd
  WRITE(*,*)"precision:",sd/vfes
  !CALL GETDAT(iyr1,imon1,iday1)                                                
  !CALL GETTIM(ihr1,imin1,isec1,i100th1)                                        
  CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
  iday1=iday1-iday0
  ihr1=ihr1-ihr0
  imin1=imin1-imin0
  isec1=isec1-isec0
  i100th1=i100th1-i100th0
  CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
  WRITE(*,*)" "
  ii=ii+1
ENDDO
rslt(1)=vfes
rslt(2)=sd
rslt(3)=chi2a
END SUBROUTINE BB_1FS

FUNCTION BB_1FS_fxn(x,wgt)
REAL(KIND=DBL),DIMENSION(varnum),INTENT(IN)::x
REAL(KIND=DBL),INTENT(IN)::wgt
REAL(KIND=DBL)::BB_1FS_fxn,sqs,m1r
REAL(KIND=DBL)::sq,m12
REAL(KIND=DBL)::temp1,ymax,ymin,Jy,y
REAL(KIND=DBL)::wme,wme0,ptp,pqp,pi,wsf,recmax,recmin,y1cup,y1clow
REAL(KIND=DBL),DIMENSION(4)::pmom
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::lr,sr
INTEGER::init=0,kk,j,istat,nnn,pdfnumpdf,icut
SAVE init,sqs,m1r,m12,sq,temp1,ymin,ymax,pi,lr,sr
SAVE nnn,recmax,recmin,y1cup,y1clow,Jy
IF(init.EQ.0)THEN
    pi=DACOS(-1d0)
    wjac=1
    CALL ReadElem_real("energy",sqs)
    CALL ReadElem_real("maxy1c",y1cup)
    CALL ReadElem_real("miny1c",y1clow)
    CALL ReadElem_integer('pdf',pdfnumpdf)
    ptc(3:20)=0                   ! Debug
    drc(3:20,3:20)=0
    etac(3:20)=20
    ec(3:20)=0
    c1(3:20)=1
    c2(3:20)=1
    cc(3:20,3:20)=1
    gmas(3:20,3:20)=0             ! Debug
    gbeammass(1:2,3:20)=0d0

    parmas(0)=0
    parwid(0)=-1
    iPDFSUP1=pdfnumpdf
    IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
        istruc=0
    ELSE
        istruc=1
    ENDIF
    istat=0
    xp1=1
    xp2=1
    IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
        CALL readcuts_HC
        y1cup=MIN(y1cup,yycut(hadron2parton(3)))
        y1clow=MAX(y1clow,yycutlow(hadron2parton(3)))
        y1cup = ABS(y1cup)
        y1clow = ABS(y1clow)
    ELSEIF(COLL_TYPE.EQ.3)THEN
        CALL readcuts_epem
    ENDIF
    IF(lnum.NE.0)THEN
        ALLOCATE(lr(lnum))
    ENDIF
    IF(snum.NE.0)THEN
        ALLOCATE(sr(snum))
    ENDIF
    IF(istat.NE.0)THEN
        PRINT *,"Wrong in allocation of array in BB_1FS_fxn !STOP !"
        STOP
    ENDIF
    kk=3
    IF(ABS(iflh(3)).GT.100)THEN
        m1r=parmas(ifl(kk))+parmas(ifl(kk+1))
        kk=kk+2
    ELSE
        m1r=parmas(ifl(kk))
        kk=kk+1
    ENDIF
    sq=sqs*sqs
    m12=m1r*m1r
    IF(m12.LE.0d0)THEN
        PRINT *,"ERROR: 2 > 1 with massless final state ?"
        PRINT *,"m = ", m1r
        PRINT *,"sqrtS = ",sqs 
        STOP
    ENDIF
    IF(DLOG(sq/m12)/2d0.LE.y1clow)THEN
        PRINT *,"ERROR: outside the rapidity cuts !"
        PRINT *,"m = ",m1r
        PRINT *,"sqrtS = ",sqs
        PRINT *,"yclow = ",y1clow
        STOP
    ENDIF
! ============================================================
! tau=x1*x2, y=1/2*log(x1/x2) => dtau dy = dx1 dx2
! 2>1 body phase space
! pi/2/M^3 delta(M-sqrt(S*tau)) dtau dy = pi/2/M^3 * 2M/S dy
! x1 = sqrt(M^2/S) Exp(y), x2 = sqrt(M^2/S) Exp(-y)
! => |y|<1/2*log(S/M^2)
! ============================================================
    temp1=pi/m12/sq ! phase space factor
    ymax=MIN(ABS(y1cup),DLOG(sq/m12)/2d0) ! upper limit of y
    ymin=MAX(ABS(y1clow),0d0) ! lower limit of y
    Jy=2d0*(ymax-ymin)*temp1 ! jacobian* phase space factor
    IF(ptQ)THEN
        PRINT *, "WARNING:Pt = 0 in 2 > 1 processes ! Calculating cross section instead !"
    ENDIF
    init=1
ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! The physical region of the integration
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! total cross section
y=(2d0*x(1)-1d0)*(ymax-ymin)+SIGN(1d0,x(1)-0.5d0)*ymin
xp1=DSQRT(m12/sq)*DEXP(y)
xp2=DSQRT(m12/sq)*DEXP(-y)
ehat=DSQRT(m12)
! Generate the momenta of external legs
Phegas_pmom(1,1:2)=0
Phegas_pmom(1,3)=xp1*sqs/2d0
Phegas_pmom(1,4)=xp1*sqs/2d0
Phegas_pmom(1:2,5)=0
Phegas_pmom(2,1:2)=0
Phegas_pmom(2,3)=-xp2*sqs/2d0
Phegas_pmom(2,4)=xp2*sqs/2d0
kk=3
pmom(1)=0
pmom(2)=0
pmom(3)=(xp1-xp2)*sqs/2d0
pmom(4)=(xp1+xp2)*sqs/2d0
IF(ABS(iflh(3)).GT.100)THEN
    Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
    Phegas_pmom(kk,5)=parmas(ifl(kk))
    Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
    Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
    kk=kk+2
ELSE
    Phegas_pmom(kk,1:4)=pmom(1:4)
    Phegas_pmom(kk,5)=parmas(ifl(kk))
    kk=kk+1
ENDIF
! boost from lab frame to cms
pmom(3)=-(xp1-xp2)*sqs/2d0
pmom(4)=(xp1+xp2)*sqs/2d0
pmom(1:2)=0
DO j=1,n
    IF(imode.EQ.0)CALL Boostl2(ehat,pmom,Phegas_pmom(j,1:4))
    ptp=DSQRT(Phegas_pmom(j,1)**2+Phegas_pmom(j,2)**2)
    pqp=DSQRT(ptp**2+Phegas_pmom(j,3)**2)
    zq(j,1)= DCMPLX(Phegas_pmom(j,4)+Phegas_pmom(j,3),Phegas_pmom(j,3))
    zq(j,2)= DCMPLX(Phegas_pmom(j,4)-Phegas_pmom(j,3),ptp)
    zq(j,3)= DCMPLX(Phegas_pmom(j,1), Phegas_pmom(j,2))
    zq(j,4)= DCMPLX(Phegas_pmom(j,1),-Phegas_pmom(j,2))
    zq(j,5)= DCMPLX(parmas(ifl(j)),pqp )
ENDDO
icut=1
IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
    CALL Cuts_HC(icut)
ELSEIF(COLL_TYPE.EQ.3)THEN
    CALL Cuts_epem(icut)
ELSE
    icut=1
ENDIF

IF(icut.EQ.0)THEN
    BB_1FS_fxn=0d0
    RETURN
ENDIF
! Reloading Feynman Rules
IF(irun.EQ.1)CALL Helac_FeynRule_SM()
! set the random number for random helicity method
kk=2
DO j=1,lnum
    lr(j)=2*pi*x(kk)
    kk=kk+1
ENDDO
DO j=1,snum
    sr(j)=2*pi*x(kk)
    kk=kk+1
ENDDO
CALL SetRandom(lr,sr)
! Generate the square of matrix element
CALL Helac_master_f(wme)
GLOBALINIT_master=1
CALL strf_pdf_cteq(wsf)
BB_1FS_fxn=wme*wsf*LDMEwt*Jy*3.8938573d5
nnn=nnn+1
IF(recmax.LT.BB_1FS_fxn)recmax=BB_1FS_fxn
IF(recmin.GT.BB_1FS_fxn)recmin=BB_1FS_fxn
IF(MOD(nnn,10000).EQ.0)THEN
PRINT *,"max=",recmax
PRINT *,"min=",recmin
ENDIF
END FUNCTION BB_1FS_fxn
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! The Cross Section of BoundState BoundState -> 2 Final States
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE BB_2FS(rslt,itmxn,ncalln)
IMPLICIT NONE
REAL(KIND=DBL),DIMENSION(3),INTENT(OUT)::rslt   ! rslt(1)=cross section ,rslt(2)=sigma,rslt(3)=chi2
INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
REAL(KIND=DBL)::vfes,sd,chi2a
INTEGER::ncalm,nc,ii
CHARACTER(len=4),DIMENSION(20)::chchar
INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
CALL ReadElem_logic("ptdisQ",ptQ)
NPRN=-1
IF(iranhel.EQ.0)THEN
	IF(ptQ)THEN
		varnum=2
	ELSE
		varnum=3
	ENDIF
	lnum=0
	snum=0
ELSEIF(iranhel.EQ.1)THEN
	IF(ptQ)THEN
		varnum=2
	ELSE
		varnum=3
	ENDIF
	lnum=0
	snum=0
	DO ii=1,nhad
		IF(ABS(iflh(ii)).LT.40)THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
	ENDDO
ELSEIF(iranhel.EQ.2)THEN
	IF(ptQ)THEN
		varnum=2
	ELSE
		varnum=3
	ENDIF
	lnum=0
	snum=0
	DO ii=1,nhad
		IF(ABS(iflh(ii)).LT.40)THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
		IF(QN1P1F(ii).OR.QN3PJF(ii))THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
	ENDDO
ELSEIF(iranhel.EQ.3)THEN
	IF(ptQ)THEN
		varnum=2
	ELSE
		varnum=3
	ENDIF
	DO ii=1,nhad
		IF(ABS(iflh(ii)).LT.40)THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
		IF(QN1P1F(ii))THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
		IF(QN3S1F(ii))THEN
			varnum=varnum+1
			snum=snum+1
		ENDIF
		IF(QN3PJF(ii))THEN
			varnum=varnum+2
			lnum=lnum+1
			snum=snum+1
		ENDIF
	ENDDO
ENDIF
DO ii=1,varnum
	XL(ii)=0.0d0
	XU(ii)=1.0d0
ENDDO
IF(PRESENT(itmxn))THEN
   ITMX=itmxn
ELSE
   ITMX=5
END IF
ITMX=1
IF(PRESENT(ncalln))THEN
   ncalm=ncalln
ELSE
   ncalm=5000
END IF
chchar(1)="40K"
chchar(2)="80K"
chchar(3)="160K"
chchar(4)="320K"
chchar(5)="640K"
chchar(6)="1M"
chchar(7)="2M"
chchar(8)="4M"
chchar(9)="8M"
chchar(10)="16M"
chchar(11)='32M'
chchar(12)='64M'
chchar(13)='120M'
chchar(14)='240M'
chchar(15)='480M'
chchar(16)='960M'
chchar(17)='2G'
chchar(18)='4G'
chchar(19)='8G'
chchar(20)='16G'
! call vegas and result
NCALL=20000
!CALL GETDAT(iyr0,imon0,iday0)
!CALL GETTIM(ihr0,imin0,isec0,i100th0)
CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
IF(measurespeed)THEN
   NCALL=500
   CALL VEGAS(varnum,BB_2FS_fxn,vfes,sd,chi2a)
   CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
   iyr1=iyr1-iyr0
   imon1=imon1-imon0
   iday1=iday1-iday0
   ihr1=ihr1-ihr0
   imin1=imin1-imin0
   isec1=isec1-isec0
   i100th1=i100th1-i100th0
   CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
   NCALL=20000
ENDIF
CALL VEGAS(varnum,BB_2FS_fxn,vfes,sd,chi2a)
WRITE(*,*)' '
WRITE(*,*)"====================NCALL=20K==========================="
WRITE(*,*)" "
CALL Helac_mtime()
WRITE(*,*)" "
ii=1
WRITE(*,*)"ITERATION ",ii,":"
WRITE(*,*)vfes,"+\-",sd
WRITE(*,*)"precision:",sd/vfes
DO ii=2,10
	CALL VEGAS(varnum,BB_2FS_fxn,vfes,sd,chi2a,1)
	WRITE(*,*)"ITERATION ",ii,":"
	WRITE(*,*)vfes,"+\-",sd
	WRITE(*,*)"precision:",sd/vfes
ENDDO
!CALL GETDAT(iyr1,imon1,iday1)
!CALL GETTIM(ihr1,imin1,isec1,i100th1)
CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
iday1=iday1-iday0
ihr1=ihr1-ihr0
imin1=imin1-imin0
isec1=isec1-isec0
i100th1=i100th1-i100th0
CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
WRITE(*,*)' '
WRITE(*,*)' '
!CALL VEGAS(3,BB_2FS_fxn,vfes,sd,chi2a,1)
!ITMX=1
ii=1
DO
  nc=2*NCALL
  IF(nc.GT.ncalm)EXIT
  NCALL=nc
  !CALL GETDAT(iyr0,imon0,iday0)
  !CALL GETTIM(ihr0,imin0,isec0,i100th0)
  CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
  WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
  WRITE(*,*)" "
  CALL Helac_mtime()
  WRITE(*,*)" "
  CALL VEGAS(varnum,BB_2FS_fxn,vfes,sd,chi2a,1)
  WRITE(*,*)vfes,"+\-",sd
  WRITE(*,*)"precision:",sd/vfes
  !CALL GETDAT(iyr1,imon1,iday1)
  !CALL GETTIM(ihr1,imin1,isec1,i100th1)
  CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
  iday1=iday1-iday0
  ihr1=ihr1-ihr0
  imin1=imin1-imin0
  isec1=isec1-isec0
  i100th1=i100th1-i100th0
  CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
  WRITE(*,*)" "
  ii=ii+1
ENDDO
rslt(1)=vfes
rslt(2)=sd
rslt(3)=chi2a
END SUBROUTINE BB_2FS

FUNCTION BB_2FS_fxn(x,wgt)
REAL(KIND=DBL),DIMENSION(varnum),INTENT(IN)::x
REAL(KIND=DBL),INTENT(IN)::wgt
REAL(KIND=DBL)::BB_2FS_fxn,sqs,m1r,m2r
REAL(KIND=DBL)::pt,y1,y2,mt1,mt2,sq,m12,m22
REAL(KIND=DBL)::temp1,temp2,temp3,temp4,Jpt2,Jy1,Jy2
REAL(KIND=DBL)::wme,wme0,ptp,pqp,pi,wsf,recmax,recmin,pt1c,y1cup,y1clow
REAL(KIND=DBL),DIMENSION(4)::pmom
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::lr,sr
INTEGER::init=0,kk,j,istat,nnn,pdfnumpdf,icut
SAVE init,sqs,m1r,m2r,m12,m22,sq,temp1,pi,lr,sr,pt
SAVE nnn,recmax,recmin,pt1c,y1cup,y1clow
IF(init.EQ.0)THEN
	pi=DACOS(-1d0)
	wjac=1
	CALL ReadElem_real("energy",sqs)
	CALL ReadElem_real("minpt1c",pt1c)
	CALL ReadElem_real("maxy1c",y1cup)
	CALL ReadElem_real("miny1c",y1clow)
	CALL ReadElem_integer('pdf',pdfnumpdf)
	ptc(3:20)=0                   ! Debug
	drc(3:20,3:20)=0
	etac(3:20)=20
	ec(3:20)=0
	c1(3:20)=1
	c2(3:20)=1
	cc(3:20,3:20)=1
	gmas(3:20,3:20)=0             ! Debug
        gbeammass(1:2,3:20)=0

        parmas(0)=0
        parwid(0)=-1
	iPDFSUP1=pdfnumpdf
	IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
		istruc=0
	ELSE
		istruc=1
	ENDIF
	istat=0
	xp1=1
        xp2=1
	IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
		CALL readcuts_HC
                y1cup=MIN(y1cup,yycut(hadron2parton(3)))
                y1clow=MAX(y1clow,yycutlow(hadron2parton(3)))
	ELSEIF(COLL_TYPE.EQ.3)THEN
		CALL readcuts_epem
	ENDIF
	IF(lnum.NE.0)THEN
		ALLOCATE(lr(lnum))
	ENDIF
	IF(snum.NE.0)THEN
		ALLOCATE(sr(snum))
	ENDIF
	IF(istat.NE.0)THEN
		PRINT *,"Wrong in allocation of array in BB_2FS_fxn !STOP !"
		STOP
	ENDIF
	kk=3
	IF(ABS(iflh(3)).GT.100)THEN
		m1r=parmas(ifl(kk))+parmas(ifl(kk+1))
		kk=kk+2
	ELSE
		m1r=parmas(ifl(kk))
		kk=kk+1
	ENDIF
	IF(ABS(iflh(4)).GT.100)THEN
		m2r=parmas(ifl(kk))+parmas(ifl(kk+1))
		kk=kk+2
	ELSE
		m2r=parmas(ifl(kk))
		kk=kk+1
	ENDIF
	sq=sqs*sqs
	m12=m1r*m1r
	m22=m2r*m2r
	temp1=DSQRT(lamda_func(sq,m12,m22))/(2d0*sqs)
	IF(ptQ)THEN
		CALL ReadElem_real("Pt1",pt)
	ENDIF
	init=1
ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! The physical region of the integration
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF(.NOT.ptQ)THEN
! total cross section
	pt=(temp1-pt1c)*x(3)+pt1c
	mt1=DSQRT(pt*pt+m1r*m1r)
	mt2=DSQRT(pt*pt+m2r*m2r)
	temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup)
	IF(temp2.LT.y1clow)THEN
		BB_2FS_fxn=0d0
		RETURN
	ENDIF
	y1=(2d0*x(1)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1)-0.5d0)*y1clow
	temp3=DLOG((-DEXP(-y1)*mt1 +sqs)/mt2)
	temp4=temp3+DLOG((-DEXP(y1)*mt1 + sqs)/mt2)
	y2= -temp3 +temp4*x(2)
!phi=x(4)*2*pi
!Jacobi Determinations
	Jpt2=2d0*pt*(temp1-pt1c)
	Jy1=2d0*(temp2-y1clow)
	Jy2=temp4
ELSE
! pt distribution
	mt1=DSQRT(pt*pt+m1r*m1r)
	mt2=DSQRT(pt*pt+m2r*m2r)
	temp2=MIN(ACosh_p((sq+m12-m22)/(2d0*sqs*mt1)),y1cup)
	IF(temp2.LT.y1clow)THEN
		BB_2FS_fxn=0d0
		RETURN
	ENDIF
	y1=(2d0*x(1)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1)-0.5d0)*y1clow
	temp3=DLOG((-DEXP(-y1)*mt1 +sqs)/mt2)
	temp4=temp3+DLOG((-DEXP(y1)*mt1 + sqs)/mt2)
	y2= -temp3 +temp4*x(2)
!phi=x(4)*2*pi
!Jacobi Determinations
	Jpt2=2d0*pt
	Jy1=2d0*(temp2-y1clow)
	Jy2=temp4
ENDIF
! The substitution of original variations
xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2)/sqs
xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2)/sqs
ehat=DSQRT(xp1*xp2*sq)
! Generate the momenta of external legs
Phegas_pmom(1,1:2)=0
Phegas_pmom(1,3)=xp1*sqs/2d0
Phegas_pmom(1,4)=xp1*sqs/2d0
Phegas_pmom(1:2,5)=0
Phegas_pmom(2,1:2)=0
Phegas_pmom(2,3)=-xp2*sqs/2d0
Phegas_pmom(2,4)=xp2*sqs/2d0
! we choose phi=0
kk=3
pmom(1)=pt
pmom(2)=0
pmom(3)=mt1*DSINH(y1)
pmom(4)=mt1*DCOSH(y1)
IF(ABS(iflh(3)).GT.100)THEN
	Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
	kk=kk+2
ELSE
	Phegas_pmom(kk,1:4)=pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	kk=kk+1
ENDIF
pmom(1)=-pt
pmom(2)=0
pmom(3)=mt2*DSINH(y2)
pmom(4)=mt2*DCOSH(y2)
IF(ABS(iflh(4)).GT.100)THEN
	Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
	kk=kk+2
ELSE
	Phegas_pmom(kk,1:4)=pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	kk=kk+1
ENDIF
! boost from lab frame to cms
pmom(3)=-(xp1-xp2)*sqs/2d0
pmom(4)=(xp1+xp2)*sqs/2d0
pmom(1:2)=0
DO j=1,n
	IF(imode.EQ.0)CALL Boostl2(ehat,pmom,Phegas_pmom(j,1:4))
	ptp=DSQRT(Phegas_pmom(j,1)**2+Phegas_pmom(j,2)**2)
	pqp=DSQRT(ptp**2+Phegas_pmom(j,3)**2)
	zq(j,1)= DCMPLX(Phegas_pmom(j,4)+Phegas_pmom(j,3),Phegas_pmom(j,3))
	zq(j,2)= DCMPLX(Phegas_pmom(j,4)-Phegas_pmom(j,3),ptp)
	zq(j,3)= DCMPLX(Phegas_pmom(j,1), Phegas_pmom(j,2))
	zq(j,4)= DCMPLX(Phegas_pmom(j,1),-Phegas_pmom(j,2))
	zq(j,5)= DCMPLX(parmas(ifl(j)),pqp )
ENDDO
icut=1
IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
	CALL Cuts_HC(icut)
ELSEIF(COLL_TYPE.EQ.3)THEN
	CALL Cuts_epem(icut)
ELSE
	icut=1
ENDIF

IF(icut.EQ.0)THEN
	BB_2FS_fxn=0d0
	RETURN
ENDIF
! Reloading Feynman Rules
IF(irun.EQ.1)CALL Helac_FeynRule_SM()
! set the random number for random helicity method
IF(ptQ)THEN
	kk=3
ELSE
	kk=4
ENDIF
DO j=1,lnum
	lr(j)=2*pi*x(kk)
	kk=kk+1
ENDDO
DO j=1,snum
	sr(j)=2*pi*x(kk)
	kk=kk+1
ENDDO
CALL SetRandom(lr,sr)
! Generate the square of matrix element
CALL Helac_master_f(wme)
GLOBALINIT_master=1
CALL strf_pdf_cteq(wsf)
BB_2FS_fxn=wme*wsf*LDMEwt/(16d0*pi*ehat**4)&
           *xp1*xp2*Jpt2*Jy1*Jy2*3.8938573d5
nnn=nnn+1
IF(recmax.LT.BB_2FS_fxn)recmax=BB_2FS_fxn
IF(recmin.GT.BB_2FS_fxn)recmin=BB_2FS_fxn
IF(MOD(nnn,10000).EQ.0)THEN
	PRINT *,"max=",recmax
	PRINT *,"min=",recmin
ENDIF
END FUNCTION BB_2FS_fxn

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! The Cross Section of BoundState BoundState -> 3 Final States
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE BB_3FS(rslt,itmxn,ncalln)
IMPLICIT NONE
REAL(KIND=DBL),DIMENSION(3),INTENT(OUT)::rslt   ! rslt(1)=cross section ,rslt(2)=sigma,rslt(3)=chi2
!REAL(KIND=DBL)::sqs,m1,m2,m3                    ! sqs is the total energy of the collider;
                                                ! m1,m2,m3 are the masses of the final states;
!REAL(KIND=DBL),EXTERNAL::ME_Func               ! ME_Func should include |M|^2
                                                ! (with average initial states) and pdf1*pdf2
INTEGER,INTENT(IN),OPTIONAL::itmxn,ncalln
!REAL(KIND=DBL),DIMENSION(2),INTENT(IN)::mu     ! mu(1)=renormalization scale
                                                ! mu(2)=factorization scale
REAL(KIND=DBL)::vfes,sd,chi2a
INTEGER::ncalm,nc,ii
CHARACTER(len=4),DIMENSION(20)::chchar
INTEGER::iday0,ihr0,imin0,isec0,i100th0,iday1,ihr1,imin1,isec1,i100th1,iyr0,iyr1,imon0,imon1
CALL ReadElem_logic("ptdisQ",ptQ)
NPRN=-1
IF(iranhel.EQ.0)THEN
	IF(ptQ)THEN
		varnum=5
	ELSE
		varnum=6
	ENDIF
	lnum=0
	snum=0
ELSEIF(iranhel.EQ.1)THEN
	IF(ptQ)THEN
		varnum=5
	ELSE
		varnum=6
	ENDIF
	lnum=0
	snum=0
	DO ii=1,nhad
		IF(ABS(iflh(ii)).LT.40)THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
	ENDDO
ELSEIF(iranhel.EQ.2)THEN
	IF(ptQ)THEN
		varnum=5
	ELSE
		varnum=6
	ENDIF
	lnum=0
	snum=0
	DO ii=1,nhad
		IF(ABS(iflh(ii)).LT.40)THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
		IF(QN1P1F(ii).OR.QN3PJF(ii))THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
	ENDDO
ELSEIF(iranhel.EQ.3)THEN
	IF(ptQ)THEN
		varnum=5
	ELSE
		varnum=6
	ENDIF
	lnum=0
	snum=0
	DO ii=1,nhad
		IF(ABS(iflh(ii)).LT.40)THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
		IF(QN1P1F(ii))THEN
			varnum=varnum+1
			lnum=lnum+1
		ENDIF
		IF(QN3S1F(ii))THEN
			varnum=varnum+1
			snum=snum+1
		ENDIF
		IF(QN3PJF(ii))THEN
			varnum=varnum+2
			lnum=lnum+1
			snum=snum+1
		ENDIF
	ENDDO
ENDIF
DO ii=1,varnum
	XL(ii)=0.0d0
	XU(ii)=1.0d0
ENDDO
IF(PRESENT(itmxn))THEN
   ITMX=itmxn
ELSE
   ITMX=5
END IF
ITMX=1
IF(PRESENT(ncalln))THEN
   ncalm=ncalln
ELSE
   ncalm=5000
END IF

! call vegas and result
NCALL=20000
!CALL GETDAT(iyr0,imon0,iday0)
!CALL GETTIM(ihr0,imin0,isec0,i100th0)
CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
IF(measurespeed)THEN
   NCALL=500
   CALL VEGAS(varnum,BB_3FS_fxn,vfes,sd,chi2a)
   CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
   iyr1=iyr1-iyr0
   imon1=imon1-imon0
   iday1=iday1-iday0
   ihr1=ihr1-ihr0
   imin1=imin1-imin0
   isec1=isec1-isec0
   i100th1=i100th1-i100th0
   CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
   NCALL=20000
ENDIF
CALL VEGAS(varnum,BB_3FS_fxn,vfes,sd,chi2a)
WRITE(*,*)"====================NCALL=20K==========================="
WRITE(*,*)" "
CALL Helac_mtime()
WRITE(*,*)" "
ii=1
WRITE(*,*)"ITERATION ",ii,":"
WRITE(*,*)vfes,"+\-",sd
WRITE(*,*)"precision:",sd/vfes
DO ii=2,10
	CALL VEGAS(varnum,BB_3FS_fxn,vfes,sd,chi2a,1)
	WRITE(*,*)"ITERATION ",ii,":"
	WRITE(*,*)vfes,"+\-",sd
	WRITE(*,*)"precision:",sd/vfes
ENDDO
!CALL GETDAT(iyr1,imon1,iday1)
!CALL GETTIM(ihr1,imin1,isec1,i100th1)
CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
iday1=iday1-iday0
ihr1=ihr1-ihr0
imin1=imin1-imin0
isec1=isec1-isec0
i100th1=i100th1-i100th0
CALL Vegas_speed(10*NCALL,iday1,ihr1,imin1,isec1,i100th1)
WRITE(*,*)''
WRITE(*,*)' '
chchar(1)="40K"
chchar(2)="80K"
chchar(3)="160K"
chchar(4)="320K"
chchar(5)="640K"
chchar(6)="1M"
chchar(7)="2M"
chchar(8)="4M"
chchar(9)="8M"
chchar(10)="16M"
chchar(11)='32M'
chchar(12)='64M'
chchar(13)='120M'
chchar(14)='240M'
chchar(15)='480M'
chchar(16)='960M'
chchar(17)='2G'
chchar(18)='4G'
chchar(19)='8G'
chchar(20)='16G'
ii=1
DO
  nc=2*NCALL
  IF(nc.GT.ncalm)EXIT
  NCALL=nc
  !CALL GETDAT(iyr0,imon0,iday0)
  !CALL GETTIM(ihr0,imin0,isec0,i100th0)
  CALL DAYTIME(iyr0,imon0,iday0,ihr0,imin0,isec0,i100th0)
  WRITE(*,*)"====================NCALL="//chchar(ii)//"==========================="
  WRITE(*,*)" "
  CALL Helac_mtime()
  WRITE(*,*)" "
  CALL VEGAS(varnum,BB_3FS_fxn,vfes,sd,chi2a,1)
  WRITE(*,*)vfes,"+\-",sd  
  WRITE(*,*)"precision:",sd/vfes
  !CALL GETDAT(iyr1,imon1,iday1)
  !CALL GETTIM(ihr1,imin1,isec1,i100th1)
  CALL DAYTIME(iyr1,imon1,iday1,ihr1,imin1,isec1,i100th1)
  iday1=iday1-iday0
  ihr1=ihr1-ihr0
  imin1=imin1-imin0
  isec1=isec1-isec0
  i100th1=i100th1-i100th0
  CALL Vegas_speed(NCALL,iday1,ihr1,imin1,isec1,i100th1)
  WRITE(*,*)" "
  ii=ii+1
ENDDO
rslt(1)=vfes
rslt(2)=sd
rslt(3)=chi2a
END SUBROUTINE BB_3FS

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Define the external function
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION BB_3FS_fxn(x,wgt)
REAL(KIND=DBL),DIMENSION(varnum),INTENT(IN)::x
REAL(KIND=DBL),INTENT(IN)::wgt
REAL(KIND=DBL)::BB_3FS_fxn,m1r,m2r,m3r,sqs
REAL(KIND=DBL)::pt1,pt12,pt2,y1,y2,y3,phi,mt1,mt2,mt3,sq,m12,m22,m32,aa,ff,ma,hh,cosphi,cosphi2
REAL(KIND=DBL)::temp1,temp2,temp3,temp4,temp5,temp6,Jpt22,Jpt12,Jy1,Jy2,Jy3,Jphi,&
                lh         ! in 2-> 3, we use t=p2k2 u=p1k2
INTEGER::init=0,kk,j,icut,istat,nnn=0,pdfnumpdf
REAL(KIND=DBL),DIMENSION(:),ALLOCATABLE::lr,sr
REAL(KIND=DBL)::ptp,pqp,wme,wme0,pi,wsf,y1cup,y1clow,pt1c,recmax=0,recmin=0
REAL(KIND=DBL),DIMENSION(4)::pmom
SAVE init,sqs,sq,m1r,m2r,m3r,m12,m22,m32,temp1,pi,y1cup,y1clow,pt1c,lr,sr,pt1,pt12
SAVE nnn,recmax,recmin
IF(init.EQ.0)THEN
	pi=DACOS(-1d0)
	wjac=1
	CALL ReadElem_real("energy",sqs)
	CALL ReadElem_real("minpt1c",pt1c)
	CALL ReadElem_real("maxy1c",y1cup)
	CALL ReadElem_real("miny1c",y1clow)
	CALL ReadElem_integer('pdf',pdfnumpdf)
	ptc(3:20)=0                   ! Debug
	drc(3:20,3:20)=0
	etac(3:20)=20
	ec(3:20)=0
	c1(3:20)=1
	c2(3:20)=1
	cc(3:20,3:20)=1
	gmas(3:20,3:20)=0             ! Debug
        gbeammass(1:2,3:20)=0

    parmas(0)=0
    parwid(0)=-1

	iPDFSUP1=pdfnumpdf
	IF(pdfnumpdf.EQ.0.OR.COLL_TYPE.EQ.3)THEN
		istruc=0
	ELSE
		istruc=1
	ENDIF
	xp1=1
    xp2=1
	IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
		CALL readcuts_HC
                y1cup=MIN(y1cup,yycut(hadron2parton(3)))
                y1clow=MAX(y1clow,yycutlow(hadron2parton(3)))
	ELSEIF(COLL_TYPE.EQ.3)THEN
		CALL readcuts_epem
	ENDIF

	kk=3
	istat=0
	IF(lnum.NE.0)THEN
		ALLOCATE(lr(lnum),STAT=istat)
	ENDIF
	IF(snum.NE.0)THEN
		ALLOCATE(sr(snum),STAT=istat)
	ENDIF
	IF(istat.NE.0)THEN
		PRINT *,"Wrong in allocation of array in BB_3FS_fxn !STOP !"
		STOP
	ENDIF
	IF(ABS(iflh(3)).GT.100)THEN
		m1r=parmas(ifl(kk))+parmas(ifl(kk+1))
		kk=kk+2
	ELSE
		m1r=parmas(ifl(kk))
		kk=kk+1
	ENDIF
	IF(ABS(iflh(4)).GT.100)THEN
		m2r=parmas(ifl(kk))+parmas(ifl(kk+1))
		kk=kk+2
	ELSE
		m2r=parmas(ifl(kk))
		kk=kk+1
	ENDIF
	IF(ABS(iflh(5)).GT.100)THEN
		m3r=parmas(ifl(kk))+parmas(ifl(kk+1))
		kk=kk+2
	ELSE
		m3r=parmas(ifl(kk))
		kk=kk+1
	ENDIF
	sq=sqs*sqs
	m12=m1r*m1r
	m22=m2r*m2r
	m32=m3r*m3r
	temp1=(DSQRT(lamda_func(sq,m12,(m2r+m3r)**2))/(2d0*sqs))
	IF(ptQ)THEN
		CALL ReadElem_real("Pt1",pt1)
		pt12=pt1*pt1
	ENDIF
	init=1
ENDIF
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! The physical region of the integration
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
IF(.NOT.ptQ)THEN
! total cross section
	pt1=(temp1-pt1c)*x(1)+pt1c
	pt12=pt1*pt1
	mt1=DSQRT(pt12+m12)
	temp2=MIN(ACosh_p((sq+m12-(m2r+m3r)**2)/(2d0*sqs*mt1)),y1cup)
	IF(temp2.LT.y1clow)THEN
		BB_3FS_fxn=0d0
		RETURN
	ENDIF
	y1=(2d0*x(2)-1d0)*(temp2-y1clow)+SIGN(1d0,x(2)-0.5d0)*y1clow
	aa=sq+mt1*mt1-2d0*sqs*mt1*DCOSH(y1)
	ff=m32+pt12
	ma=DMAX1(-lamda_func(aa,m22,ff)/(4d0*m22*pt12),0d0)
	ma=DSQRT(ma)
	phi=unit_step(1d0/2d0-x(3))*(4d0*DACOS(ma)*x(3)-DACOS(ma))&
     +unit_step(x(3)-1d0/2d0)*(2d0*(pi-DACOS(-ma))*(2d0*x(3)-1d0)+DACOS(-ma))
	cosphi=DCOS(phi)
	cosphi2=cosphi*cosphi
	hh=2d0*pt1*cosphi
	temp3=(DSQRT((4d0*aa-hh**2)*(lamda_func(aa,m22,ff))+((aa-ff+m22)*hh)**2) &
      -hh*(aa-ff+m22))/(4d0*aa-hh**2)
	pt2=x(4)*temp3
	mt2=DSQRT(pt2*pt2+m22)
	mt3=DSQRT(pt12+pt2*pt2+2d0*pt1*pt2*cosphi+m32)
	lh=(sq+m12+m22-m32-2d0*sqs*mt1*DCOSH(y1)-2d0*pt1*pt2*cosphi) &
      /(2d0*mt2*DSQRT(aa))
	IF(lh.LT.1d0)THEN
		BB_3FS_fxn=0d0
		RETURN
	ENDIF
	temp4=ACosh_p(lh)
	y2=(2d0*x(5)-1d0)*temp4+DLOG((sqs-mt1*DEXP(y1))/(sqs-mt1*DEXP(-y1)))/2d0
	temp5=DLOG((sqs-DEXP(-y1)*mt1-DEXP(-y2)*mt2)/mt3)
	temp6=temp5+DLOG((sqs-DEXP(y1)*mt1-DEXP(y2)*mt2)/mt3)
	y3= -temp5 +temp6*x(6)
!Jacobi Determinations
	Jpt12=2d0*pt1*(temp1-pt1c)
	Jy1=2d0*(temp2-y1clow)
	Jphi=unit_step(1d0/2d0-x(3))*(4d0*DACOS(ma))&
     +unit_step(x(3)-1d0/2d0)*(4d0*(pi-DACOS(-ma)))
	Jpt22=2d0*pt2*temp3
	Jy2=2d0*temp4
	Jy3=temp6
ELSE
! pt distribution
	mt1=DSQRT(pt12+m12)
	temp2=MIN(ACosh_p((sq+m12-(m2r+m3r)**2)/(2d0*sqs*mt1)),y1cup)
	IF(temp2.LT.y1clow)THEN
		BB_3FS_fxn=0d0
		RETURN
	ENDIF
	y1=(2d0*x(1)-1d0)*(temp2-y1clow)+SIGN(1d0,x(1)-0.5d0)*y1clow
	aa=sq+mt1*mt1-2d0*sqs*mt1*DCOSH(y1)
	ff=m32+pt12
	ma=DMAX1(-lamda_func(aa,m22,ff)/(4d0*m22*pt12),0d0)
	ma=DSQRT(ma)
	phi=unit_step(1d0/2d0-x(2))*(4d0*DACOS(ma)*x(2)-DACOS(ma))&
     +unit_step(x(2)-1d0/2d0)*(2d0*(pi-DACOS(-ma))*(2d0*x(2)-1d0)+DACOS(-ma))
	cosphi=DCOS(phi)
	cosphi2=cosphi*cosphi
	hh=2d0*pt1*cosphi
	temp3=(DSQRT((4d0*aa-hh**2)*(lamda_func(aa,m22,ff))+((aa-ff+m22)*hh)**2) &
      -hh*(aa-ff+m22))/(4d0*aa-hh**2)
	pt2=x(3)*temp3
	mt2=DSQRT(pt2*pt2+m22)
	mt3=DSQRT(pt12+pt2*pt2+2d0*pt1*pt2*cosphi+m32)
	lh=(sq+m12+m22-m32-2d0*sqs*mt1*DCOSH(y1)-2d0*pt1*pt2*cosphi) &
      /(2d0*mt2*DSQRT(aa))
	IF(lh.LT.1d0)THEN
		BB_3FS_fxn=0d0
		RETURN
	ENDIF
	temp4=ACosh_p(lh)
	y2=(2d0*x(4)-1d0)*temp4+DLOG((sqs-mt1*DEXP(y1))/(sqs-mt1*DEXP(-y1)))/2d0
	temp5=DLOG((sqs-DEXP(-y1)*mt1-DEXP(-y2)*mt2)/mt3)
	temp6=temp5+DLOG((sqs-DEXP(y1)*mt1-DEXP(y2)*mt2)/mt3)
	y3= -temp5 +temp6*x(5)
!Jacobi Determinations
	Jpt12=2d0*pt1
	Jy1=2d0*(temp2-y1clow)
	Jphi=unit_step(1d0/2d0-x(2))*(4d0*DACOS(ma))&
     +unit_step(x(2)-1d0/2d0)*(4d0*(pi-DACOS(-ma)))
	Jpt22=2d0*pt2*temp3
	Jy2=2d0*temp4
	Jy3=temp6
ENDIF
! The substitution of original variations
xp1=(DEXP(y1)*mt1 + DEXP(y2)*mt2+DEXP(y3)*mt3)/sqs
xp2=(DEXP(-y1)*mt1+DEXP(-y2)*mt2+DEXP(-y3)*mt3)/sqs
ehat=DSQRT(xp1*xp2*sq)
! Generate the momenta of external legs
Phegas_pmom(1,1:2)=0
Phegas_pmom(1,3)=xp1*sqs/2d0
Phegas_pmom(1,4)=xp1*sqs/2d0
Phegas_pmom(1:2,5)=0
Phegas_pmom(2,1:2)=0
Phegas_pmom(2,3)=-xp2*sqs/2d0
Phegas_pmom(2,4)=xp2*sqs/2d0
! we choose phi=0
kk=3
pmom(1)=pt1
pmom(2)=0
pmom(3)=mt1*DSINH(y1)
pmom(4)=mt1*DCOSH(y1)
IF(ABS(iflh(3)).GT.100)THEN
	Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
	kk=kk+2
ELSE
	Phegas_pmom(kk,1:4)=pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	kk=kk+1
ENDIF
pmom(1)=pt2*DCOS(phi)
pmom(2)=pt2*DSIN(phi)
pmom(3)=mt2*DSINH(y2)
pmom(4)=mt2*DCOSH(y2)
IF(ABS(iflh(4)).GT.100)THEN
	Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
	kk=kk+2
ELSE
	Phegas_pmom(kk,1:4)=pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	kk=kk+1
ENDIF
pmom(1)=-pt2*DCOS(phi)-pt1
pmom(2)=-pt2*DSIN(phi)
pmom(3)=mt3*DSINH(y3)
pmom(4)=mt3*DCOSH(y3)
IF(ABS(iflh(5)).GT.100)THEN
	Phegas_pmom(kk,1:4)=parmas(ifl(kk))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	Phegas_pmom(kk+1,1:4)=parmas(ifl(kk+1))/(parmas(ifl(kk))+parmas(ifl(kk+1)))*pmom(1:4)
	Phegas_pmom(kk+1,5)=parmas(ifl(kk+1))
	kk=kk+2
ELSE
	Phegas_pmom(kk,1:4)=pmom(1:4)
	Phegas_pmom(kk,5)=parmas(ifl(kk))
	kk=kk+1
ENDIF
! boost from lab frame to cms
pmom(3)=-(xp1-xp2)*sqs/2d0
pmom(4)=(xp1+xp2)*sqs/2d0
pmom(1:2)=0
DO j=1,n
	IF(imode.EQ.0)CALL Boostl2(ehat,pmom,Phegas_pmom(j,1:4))
	ptp=DSQRT(Phegas_pmom(j,1)**2+Phegas_pmom(j,2)**2)
	pqp=DSQRT(ptp**2+Phegas_pmom(j,3)**2)
	zq(j,1)= DCMPLX(Phegas_pmom(j,4)+Phegas_pmom(j,3),Phegas_pmom(j,3))
	zq(j,2)= DCMPLX(Phegas_pmom(j,4)-Phegas_pmom(j,3),ptp)
	zq(j,3)= DCMPLX(Phegas_pmom(j,1), Phegas_pmom(j,2))
	zq(j,4)= DCMPLX(Phegas_pmom(j,1),-Phegas_pmom(j,2))
	zq(j,5)= DCMPLX(parmas(ifl(j)),pqp )
ENDDO
! cut something
IF(COLL_TYPE.NE.3.AND.istruc.EQ.1)THEN
	CALL Cuts_HC(icut)
ELSEIF(COLL_TYPE.EQ.3)THEN
	CALL Cuts_epem(icut)
ELSE
	icut=1
ENDIF
IF(icut.EQ.0)THEN
	BB_3FS_fxn=0d0
	RETURN
ENDIF
! Reloading Feynman Rules
IF(irun.EQ.1)CALL Helac_FeynRule_SM()
! set the random number for random helicity method
IF(ptQ)THEN
	kk=6
ELSE
	kk=5
ENDIF
DO j=1,lnum
	lr(j)=2*pi*x(kk)
	kk=kk+1
ENDDO
DO j=1,snum
	sr(j)=2*pi*x(kk)
	kk=kk+1
ENDDO
CALL SetRandom(lr,sr)
! Generate the square of matrix element
CALL Helac_master_f(wme)
GLOBALINIT_master=1
! Generate weight for pdf
CALL strf_pdf_cteq(wsf)
BB_3FS_fxn=wme*wsf*LDMEwt/(512d0*(pi**4)*ehat**4)&
           *xp1*xp2*Jpt12*Jpt22*Jy1*Jy2*Jy3*Jphi*3.8938573d5
nnn=nnn+1
IF(recmax.LT.BB_3FS_fxn)recmax=BB_3FS_fxn
IF(recmin.GT.BB_3FS_fxn)recmin=BB_3FS_fxn
IF(MOD(nnn,10000).EQ.0)THEN
	PRINT *,"max=",recmax
	PRINT *,"min=",recmin
ENDIF
END FUNCTION BB_3FS_fxn

SUBROUTINE BOOSTL2(Q,PBOO,P)
! momentums are in normal representation with fourth comp is the zero comp
! Boost P via PBOO(PBOO^2=Q^2) to PLB,and set to P
IMPLICIT NONE
REAL(KIND=DBL),INTENT(IN)::Q
REAL(KIND=DBL),DIMENSION(4),INTENT(IN)::PBOO
REAL(KIND=DBL),DIMENSION(4),INTENT(INOUT)::P
REAL(KIND=DBL),DIMENSION(4)::PCM,PLB
REAL(KIND=DBL)::FACT
INTEGER::J
PCM(1:4)=P(1:4)
PLB(4)=(PBOO(4)*PCM(4)+PBOO(3)*PCM(3)+PBOO(2)*PCM(2)+PBOO(1)*PCM(1))/Q
FACT=(PLB(4)+PCM(4))/(Q+PBOO(4))
DO J=1,3
   PLB(J)=PCM(J)+FACT*PBOO(J)
ENDDO
P(1:4)=PLB(1:4)
END SUBROUTINE BOOSTL2
END MODULE Colliders_PSI_1
