MODULE func_psi
IMPLICIT NONE
REAL(KIND(1d0)),PARAMETER::pi=3.1415926535897932385d0
REAL(KIND(1d0)),PARAMETER::EulerGamma=0.57721566490153286061d0

INTERFACE unit_step
   MODULE PROCEDURE unit_step_d
   MODULE PROCEDURE unit_step_s
   MODULE PROCEDURE unit_step_i
END INTERFACE unit_step

INTERFACE DLOG2
   MODULE PROCEDURE DLOG2_d
   MODULE PROCEDURE DLOG2_c
END INTERFACE DLOG2

CONTAINS
FUNCTION lamda_func(a,b,c)
REAL(KIND(1d0))::lamda_func
REAL(KIND(1d0)),INTENT(IN)::a,b,c
lamda_func=a**2+b**2+c**2-2*a*b-2*a*c-2*b*c
END FUNCTION lamda_func

FUNCTION unit_step_d(x)
REAL(KIND(1d0))::unit_step_d
REAL(KIND(1d0))::x
IF(x.LT.0d0) THEN
   unit_step_d=0d0
ELSE
   unit_step_d=1d0
END IF
END FUNCTION unit_step_d

FUNCTION unit_step_s(x)
REAL(KIND(1d0))::unit_step_s
REAL(KIND(1.0))::x
IF(x.LT.0.0) THEN
   unit_step_s=0d0
ELSE
   unit_step_s=1d0
END IF
END FUNCTION unit_step_s

FUNCTION unit_step_i(x)
REAL(KIND(1d0))::unit_step_i
INTEGER::x
IF(x.LT.0) THEN
   unit_step_i=0d0
ELSE
   unit_step_i=1d0
END IF
END FUNCTION unit_step_i

FUNCTION ACosh_p(x)
REAL(KIND(1d0)),INTENT(IN)::x
REAL(KIND(1d0))::ACosh_p
IF(DABS(x).LT.1d0) THEN
  WRITE(*,*)"Error in ACosh_p!"
  ACosh_p=0
ELSE
  ACosh_p=DLOG(x+DSQRT(x**2-1d0))
END IF
END FUNCTION ACosh_p

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! DLOG2
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FUNCTION DLOG2_d(x)
COMPLEX(KIND(1d0))::DLOG2_d
REAL(KIND(1d0)),INTENT(IN)::x
DLOG2_d=CDLOG(DCMPLX(x))
END FUNCTION DLOG2_d
FUNCTION DLOG2_c(x)
COMPLEX(KIND(1d0))::DLOG2_c
COMPLEX(KIND(1d0)),INTENT(IN)::x
DLOG2_c=CDLOG(x)
END FUNCTION DLOG2_c
END MODULE func_psi