MODULE Structf_PDFs
USE Helac_Global
USE CTEQ6PDF
IMPLICIT NONE
CONTAINS      
SUBROUTINE strf_pdf_cteq(wsf)
!include 'declare.h'
!include 'common_int.h'
!include 'common_strf.h'
!include 'parameter_pp.h'
INTEGER::ipp=1  ! ipp=1 ppbar ; ipp=2 pp
REAL(KIND=DBL),INTENT(OUT)::wsf          
CHARACTER(len=20),DIMENSION(20)::parm
REAL(KIND=DBL),DIMENSION(20)::val
INTEGER::init=0      
SAVE init,ipp
REAL(KIND=DBL)::glu1_ct,glu2_ct,u1_ct,u2_ct,d1_ct,d2_ct,s1_ct,s2_ct,c1_ct,c2_ct,b1_ct,b2_ct,&
                ub1_ct,ub2_ct,db1_ct,db2_ct,sb1_ct,sb2_ct,cb1_ct,cb2_ct,bb1_ct,bb2_ct,sf_ct
       
IF(init.EQ.0)THEN
  SELECT CASE(iPDFSUP1)
  CASE(10000)
	CALL SetCtq6(1)
  CASE(10041)
	CALL SetCtq6(3)
  CASE DEFAULT
	CALL SetCtq6(4)
  END SELECT
  IF(Coll_Type.EQ.1)THEN
	ipp=2
  ELSE
	ipp=1
  ENDIF
  init=1
ENDIF

CALL qcdscale(scale)

glu1_ct = xp1*Ctq6Pdf(0,xp1,scale)
glu2_ct = xp2*Ctq6Pdf(0,xp2,scale)
u1_ct   = xp1*Ctq6Pdf(1,xp1,scale)
u2_ct   = xp2*Ctq6Pdf(1,xp2,scale)
d1_ct   = xp1*Ctq6Pdf(2,xp1,scale)
d2_ct   = xp2*Ctq6Pdf(2,xp2,scale)
s1_ct   = xp1*Ctq6Pdf(3,xp1,scale)
s2_ct   = xp2*Ctq6Pdf(3,xp2,scale)
c1_ct   = xp1*Ctq6Pdf(4,xp1,scale)
c2_ct   = xp2*Ctq6Pdf(4,xp2,scale)
b1_ct   = xp1*Ctq6Pdf(5,xp1,scale)
b2_ct   = xp2*Ctq6Pdf(5,xp2,scale)
ub1_ct  = xp1*Ctq6Pdf(-1,xp1,scale)
ub2_ct  = xp2*Ctq6Pdf(-1,xp2,scale)
db1_ct  = xp1*Ctq6Pdf(-2,xp1,scale)
db2_ct  = xp2*Ctq6Pdf(-2,xp2,scale)
sb1_ct  = xp1*Ctq6Pdf(-3,xp1,scale)
sb2_ct  = xp2*Ctq6Pdf(-3,xp2,scale)
cb1_ct  = xp1*Ctq6Pdf(-4,xp1,scale)
cb2_ct  = xp2*Ctq6Pdf(-4,xp2,scale)
bb1_ct  = xp1*Ctq6Pdf(-5,xp1,scale)
bb2_ct  = xp2*Ctq6Pdf(-5,xp2,scale)

sf_ct=1
IF(qsumQ)THEN
	IF(ifl(1).EQ.35)THEN
		sf_ct=sf_ct*glu1_ct
	ELSEIF(ABS(ifl(1)).LE.12.AND.(MOD(ABS(ifl(1)),4).EQ.0.OR.MOD(ABS(ifl(1)),4).EQ.3) &
	.AND.ifl(2).EQ.35)THEN
		IF(onlyqcd)THEN
			SELECT CASE(iqnum)
			CASE(1)
				sf_ct=sf_ct*(u1_ct+ub1_ct)
			CASE(2)
				sf_ct=sf_ct*(u1_ct+ub1_ct+d1_ct+db1_ct)
			CASE(3)
				sf_ct=sf_ct*(u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
			CASE(4)
				sf_ct=sf_ct*(c1_ct+cb1_ct+u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
			CASE DEFAULT
				sf_ct=sf_ct*(b1_ct+bb1_ct+c1_ct+cb1_ct+u1_ct+ub1_ct+d1_ct+db1_ct+s1_ct+sb1_ct)
			END SELECT
		ELSE
			IF(MOD(ABS(ifl(1)),4).EQ.3)THEN
				SELECT CASE(iqnum)
				CASE(1,2,3)
					sf_ct=sf_ct*(u1_ct+ub1_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(u1_ct+ub1_ct+c1_ct+cb1_ct)
				END SELECT
			ELSEIF(MOD(ABS(ifl(1)),4).EQ.0)THEN
				SELECT CASE(iqnum)
				CASE(1)
					sf_ct=sf_ct
				CASE(2)
					sf_ct=sf_ct*(d1_ct+db1_ct)
				CASE(3,4)
					sf_ct=sf_ct*(d1_ct+db1_ct+s1_ct+sb1_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(d1_ct+db1_ct+s1_ct+sb1_ct+b1_ct+bb1_ct)
				END SELECT
			ENDIF
		ENDIF
	ENDIF

	IF(ifl(2).EQ.35)THEN
		sf_ct=sf_ct*glu2_ct
	ELSEIF(ABS(ifl(2)).LE.12.AND.(MOD(ABS(ifl(2)),4).EQ.0.OR.MOD(ABS(ifl(2)),4).EQ.3) &
	.AND.ifl(1).EQ.35)THEN
		IF(onlyqcd)THEN
			SELECT CASE(iqnum)
			CASE(1)
				sf_ct=sf_ct*(u2_ct+ub2_ct)
			CASE(2)
				sf_ct=sf_ct*(u2_ct+ub2_ct+d2_ct+db2_ct)
			CASE(3)
				sf_ct=sf_ct*(u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
			CASE(4)
				sf_ct=sf_ct*(c2_ct+cb2_ct+u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
			CASE DEFAULT
				sf_ct=sf_ct*(b2_ct+bb2_ct+c2_ct+cb2_ct+u2_ct+ub2_ct+d2_ct+db2_ct+s2_ct+sb2_ct)
			END SELECT
		ELSE
			IF(MOD(ABS(ifl(2)),4).EQ.3)THEN
				SELECT CASE(iqnum)
				CASE(1,2,3)
					sf_ct=sf_ct*(u2_ct+ub2_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(u2_ct+ub2_ct+c2_ct+cb2_ct)
				END SELECT
			ELSEIF(MOD(ABS(ifl(2)),4).EQ.0)THEN
				SELECT CASE(iqnum)
				CASE(1)
					sf_ct=sf_ct
				CASE(2)
					sf_ct=sf_ct*(d2_ct+db2_ct)
				CASE(3,4)
					sf_ct=sf_ct*(d2_ct+db2_ct+s2_ct+sb2_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(d2_ct+db2_ct+s2_ct+sb2_ct+b2_ct+bb2_ct)
				END SELECT
			ENDIF
		ENDIF
	ENDIF

	IF(ifl(1)+ifl(2).EQ.0.AND.(MOD(ABS(ifl(1)),4).EQ.0.OR.MOD(ABS(ifl(1)),4).EQ.3))THEN
		IF(onlyqcd)THEN
			SELECT CASE(iqnum)
			CASE(1)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct)
			CASE(2)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct)
			CASE(3)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
				+s1_ct*sb2_ct+s2_ct*sb1_ct)
			CASE(4)
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
				+s1_ct*sb2_ct+s2_ct*sb1_ct+c1_ct*cb2_ct+cb1_ct*c2_ct)
			CASE DEFAULT
				sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
				+s1_ct*sb2_ct+s2_ct*sb1_ct+c1_ct*cb2_ct+cb1_ct*c2_ct+b1_ct*bb2_ct+bb1_ct*b2_ct)
			END SELECT
		ELSE
			IF(MOD(ABS(ifl(1)),4).EQ.3)THEN
				SELECT CASE(iqnum)
				CASE(1,2,3)
					sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(u1_ct*ub2_ct+ub1_ct*u2_ct+c1_ct*cb2_ct+c2_ct*cb1_ct)
				END SELECT
			ELSEIF(MOD(ABS(ifl(1)),4).EQ.0)THEN
				SELECT CASE(iqnum)
				CASE(1)
					sf_ct=sf_ct
				CASE(2)
					sf_ct=sf_ct*(d1_ct*db2_ct+d2_ct*db1_ct)
				CASE(3,4)
					sf_ct=sf_ct*(s1_ct*sb2_ct+sb1_ct*s2_ct+d1_ct*db2_ct+d2_ct*db1_ct)
				CASE DEFAULT
					sf_ct=sf_ct*(s1_ct*sb2_ct+sb1_ct*s2_ct+d1_ct*db2_ct+d2_ct*db1_ct&
					+b1_ct*bb2_ct+b2_ct*bb1_ct)
				END SELECT
			ENDIF
		ENDIF
	ELSEIF(ifl(1).NE.35.AND.ifl(2).NE.35)THEN
		PRINT *,"Please choose quarksumQ=.FALSE."
		STOP
	ENDIF

ELSE      
	IF(ipp.EQ.1)THEN
	! ppbar
		SELECT CASE(ifl(1))  
		CASE(3)
			sf_ct=sf_ct*u1_ct
		CASE(-3) 
			sf_ct=sf_ct*ub1_ct
		CASE(4)  
			sf_ct=sf_ct*d1_ct
		CASE(-4) 
			sf_ct=sf_ct*db1_ct
		CASE(7)  
			sf_ct=sf_ct*c1_ct
		CASE(-7) 
			sf_ct=sf_ct*cb1_ct
		CASE(8)  
			sf_ct=sf_ct*s1_ct
		CASE(-8) 
			sf_ct=sf_ct*sb1_ct
!   IF(ifl(1).EQ.11) sf_ct=sf_ct*t1_ct
!   IF(ifl(1).EQ.-11)sf_ct=sf_ct*tb1_ct
		CASE(12) 
			sf_ct=sf_ct*b1_ct
		CASE(-12)
			sf_ct=sf_ct*bb1_ct
		CASE(35) 
			sf_ct=sf_ct*glu1_ct
		END SELECT

		SELECT CASE(ifl(2))
		CASE(3)
			sf_ct=sf_ct*ub2_ct
		CASE(-3) 
			sf_ct=sf_ct*u2_ct
		CASE(4)  
			sf_ct=sf_ct*db2_ct
		CASE(-4) 
			sf_ct=sf_ct*d2_ct
		CASE(7)  
			sf_ct=sf_ct*cb2_ct
		CASE(-7) 
			sf_ct=sf_ct*c2_ct
		CASE(8)  
			sf_ct=sf_ct*sb2_ct
		CASE(-8) 
			sf_ct=sf_ct*s2_ct
!       if(ifl(2).eq.11) sf=sf*t2
!       if(ifl(2).eq.-11)sf=sf*tb2
		CASE(12) 
			sf_ct=sf_ct*bb2_ct
		CASE(-12)
			sf_ct=sf_ct*b2_ct
		CASE(35) 
			sf_ct=sf_ct*glu2_ct
		END SELECT
	ELSEIF(ipp.EQ.2)THEN
! pp
		SELECT CASE(ifl(1))
		CASE(3)  
			sf_ct=sf_ct*u1_ct
		CASE(-3) 
			sf_ct=sf_ct*ub1_ct
		CASE(4)  
			sf_ct=sf_ct*d1_ct
		CASE(-4) 
			sf_ct=sf_ct*db1_ct
		CASE(7)  
			sf_ct=sf_ct*c1_ct
		CASE(-7) 
			sf_ct=sf_ct*cb1_ct
		CASE(8)  
			sf_ct=sf_ct*s1_ct
		CASE(-8) 
			sf_ct=sf_ct*sb1_ct
!       if(ifl(1).eq.11) sf=sf*t1
!       if(ifl(1).eq.-11)sf=sf*tb1
		CASE(12) 
			sf_ct=sf_ct*b1_ct
		CASE(-12)
			sf_ct=sf_ct*bb1_ct
		CASE(35) 
			sf_ct=sf_ct*glu1_ct
		END SELECT

		SELECT CASE(ifl(2))
		CASE(3)  
			sf_ct=sf_ct*u2_ct
		CASE(-3) 
			sf_ct=sf_ct*ub2_ct
		CASE(4)  
			sf_ct=sf_ct*d2_ct
		CASE(-4) 
			sf_ct=sf_ct*db2_ct
		CASE(7)  
			sf_ct=sf_ct*c2_ct
		CASE(-7) 
			sf_ct=sf_ct*cb2_ct
		CASE(8)  
			sf_ct=sf_ct*s2_ct
		CASE(-8) 
			sf_ct=sf_ct*sb2_ct
!       if(ifl(2).eq.11) sf=sf*t2
!       if(ifl(2).eq.-11)sf=sf*tb2
		CASE(12) 
			sf_ct=sf_ct*b2_ct
		CASE(-12)
			sf_ct=sf_ct*bb2_ct
		CASE(35) 
			sf_ct=sf_ct*glu2_ct
		END SELECT
	ENDIF
ENDIF

!      if(ifl(1).eq. 3.and.ifl(2).eq.-3.or.
!    &    ifl(1).eq.-3.and.ifl(2).eq. 3)then
!      if(init.eq.0)print*,'qq',ifl(1),ifl(2)
!      sf =uv1*us2+us1*uv2+dv1*ds2+ds1*dv2
!    &        +2.d0*(us1*us2+ds1*ds2)            !q+q or qb+qb
!    &        +2.d0*(st1*st2+ch1*ch2+bo1*bo2)
!      endif
!      if(ifl(1).eq.35.and.ifl(2).eq.35)then 
!      if(init.eq.0)print*,'gg',ifl(1),ifl(2)
!      sf =gl1*gl2                           !g+g
!      endif                             

wsf=wjac*sf_ct/xp1/xp2
IF(init.EQ.0)init=1
       
END SUBROUTINE strf_pdf_cteq

!       include 'pdfset.h'
SUBROUTINE pdfset
!       include 'declare.h'
PRINT *,'YOU SHOULD TAKE CARE OF PDF SET LIBRARY'
STOP
END SUBROUTINE pdfset
!      subroutine structm
!SUBROUTINE structm(xp1,scale,uv1,dv1,us1,ds1,st1,ch1,bo1,to1,gl1) 
!       include 'declare.h'
!PRINT *,'YOU SHOULD TAKE CARE OF PDF SET LIBRARY'
!STOP
!END SUBROUTINE structm

FUNCTION alphas2(xxxx)
!       include 'declare.h'
REAL(KIND=DBL)::ALPHAS2
REAL(KIND=DBL),INTENT(IN)::xxxx
alphas2=0.130d0
END FUNCTION alphas2

!  end of 'pdfset.h'

!       include 'getqcdscale.h'
SUBROUTINE qcdscale(scale1)
!       include 'declare.h'      
!       include 'common_phegas_mom.h'
!       include 'common_masses.h'
!       include 'common_int.h'
REAL(KIND=DBL),INTENT(OUT)::scale1
REAL(KIND=DBL)::px,py,ptw2,mas
INTEGER::ij
SELECT CASE(nscheme)
CASE(0)
! fixed scheme
	scale1=fschemevalue
CASE(1)
! Sqrt(pt1**2+m1**2)
	IF(ABS(iflh(3)).GT.100)THEN
	! for quarkonium
		px=Phegas_pmom(3,1)+Phegas_pmom(4,1)
		py=Phegas_pmom(3,2)+Phegas_pmom(4,2)
		ptw2=px**2+py**2
		mas=parmas(ifl(3))+parmas(ifl(4))
	ELSE
		px=Phegas_pmom(3,1)
		py=Phegas_pmom(3,2)
		ptw2=px**2+py**2
		mas=parmas(ifl(3))
	ENDIF
	scale1=DSQRT(mas**2+ptw2)
CASE(2)
! Sqrt(pt1**2+sum(mi,i=3,n)**2) in Jpsi ccbar by F.Maltoni
	mas=0d0
	DO ij=3,n
		mas=mas+parmas(ifl(ij))
	ENDDO
	IF(ABS(iflh(3)).GT.100)THEN
		px=Phegas_pmom(3,1)+Phegas_pmom(4,1)
		py=Phegas_pmom(3,2)+Phegas_pmom(4,2)
	ELSE
		px=Phegas_pmom(3,1)
		py=Phegas_pmom(3,2)
	ENDIF
	ptw2=px**2+py**2
	scale1=DSQRT(mas**2+ptw2)
END SELECT
!
! default Z_mass
!
!scale1=parmas(32)
!Scale1=parmas(11)
!scale1=12.8d0

!
! example 1: pt of particles 3 and 4 (=W) + W_mass ^2
!
!      px=Phegas_pmom(3,1)+Phegas_pmom(4,1)
!      py=Phegas_pmom(3,2)+Pegas_pmom(4,2)
!      ptw2=px**2+py**2
!      scale2=parmas(33)**2+ptw2

!
! example 2: pt of 3 + pt of 4 + 2 times the top mass
!
!      pt1=Phegas_pmom(3,1)**2+Phegas_pmom(3,2)**2
!      pt2=Phegas_pmom(4,1)**2+Phegas_pmom(4,2)**2
!      scale2=2*parmas(11)**2+pt1+pt2
!      scale1=dsqrt(scale2)

scale1=scale1*scalefactor

END SUBROUTINE qcdscale
! end of 'getqcdscale.h'
END MODULE Structf_PDFs
